#include "ScriptInput.h"

const int MILLIMETERS_PER_CENTIMETER = 10;
// const int DEG_90 = 90;
// const int DEG_360 = 360;

/*NOTE: scripts have everything in cm! */
//#define TEST_LIB

ScriptInput::ScriptInput(string filename, string refFileName){
  myscript = new script(filename, refFileName.empty() ? "" : refFileName.c_str(), 1.0, false, 0, 1);
  //#define TEST_LIB
#ifdef TEST_LIB
  const int NUM_SONAR = 8; 
 double x;   double y;   double th;
  int sonarReadings[NUM_SONAR];
  int ii=0;
  //float elapsed;
  while ( update( x, y, th, SONAR_SCAN, sonarReadings ) ) {
    if (ii++ > 500) break; 
      cout << "encoder pos: " << x << " " << y << " " << th << endl;

      cout << "sonar scans: ";
      for ( int i = 0; i < NUM_SONAR; i++ )
	cout << sonarReadings[i] << " ";
      cout << endl;

      getRefPosition(x, y, th);
      cout << "ref pos: " <<  " " << x << " " << y << " " << th << endl;

    }
#endif  
}

ScriptInput::~ScriptInput() {
  if ( myscript )
    delete myscript;
}

void
ScriptInput::getRefPosition(double& x,double& y, double& t) {
  position p = myscript->getRefPosition();
  x = p.x * MILLIMETERS_PER_CENTIMETER;
  y= p.y * MILLIMETERS_PER_CENTIMETER;
  t = p.rot;
}

bool ScriptInput::update(double& x,double& y, double& t, int scanType,
			 int *scanBuffer) {
  if ( ! myscript )
    return false;

  bool ret = myscript->getNextItem(false);
  
  if( ! ret || ! scanBuffer )
    return false;

  position currpos = myscript->currentRobotPosition();
  x = currpos.x * MILLIMETERS_PER_CENTIMETER;
  y = currpos.y * MILLIMETERS_PER_CENTIMETER;
  t =- currpos.rot + 90; //weird correction

  //force range 0-360
  if(t < 0) 
    t += 360;

  
  proximityScan myscan(0);
  
  switch( scanType ) {
  case LASER_SCAN:
    myscan = myscript->getLaser();
    break;
  case SONAR_SCAN:
    myscan = myscript->getSonar();
    break;
  default:
    break;
  }
  
  for(unsigned int i = 0; i < myscan.reading.size(); i++ ) 
    scanBuffer[i] = (int) ( myscan.reading[i] * MILLIMETERS_PER_CENTIMETER );
  //elapsed = myscript->elapsedTime();
  return true;
}

#ifdef TEST_LIB
ScriptInput script("uw.script", "pos.log");
#endif
