#ifndef SCRIPT_INPUT_H
#define SCRIPT_INPUT_H

#include <fstream.h>
#include <string>
#include "script.h"
#include "script.icc"

const int LASER_SCAN = 0;
const int SONAR_SCAN = 1;

class ScriptInput {
 public:
  // filename is the name of the script file
  ScriptInput(string filename, string refFileName="");

  // destructor
  ~ScriptInput();

  // update x,y,t with current odometry from script
  // x, y - position in millimeters
  // t - theta in degrees
  // scanType - type of scan you want to fill into scanBuffer
  // scanBuffer - buffer to put the sensor readings requested by scanType
  //              sensor readings are in millimeters
  bool update(double& x,double& y, double& t, int scanType,
	      int *scanBuffer);
  void getRefPosition(double& x,double& y, double& t);
 protected:

  int delay; //in milliseconds
  float oldtime; //in sec
  script* myscript;
};

#endif
