#ifndef TIMER_LOADED
#define TIMER_LOADED

/////////////////////////////////////////////////////////////////
//  Timer to check expired times.
/////////////////////////////////////////////////////////////////
class Timer {
public:
  Timer();
  Timer(struct timeval& t);
  
  inline void             set();
  inline float            reset();
  inline float            expiredTime() const;
  inline const timeval&   time() const;
  inline float            floatTime() const;
  
  inline float            operator - (const Timer & s) const;
  inline bool             operator >= (const Timer & s) const;
  
  friend ostream& operator << (ostream& os, const Timer& t);
  friend Timer timeDiff( const Timer& t1, const Timer & t2);

  inline long &           secs();
  inline long &           usecs();

  inline const long &     constSecs() const;
  inline const long &     constUSecs() const;

protected:

  struct timeval   _time;
  
private:
  
};

inline Timer timeDiff( const Timer& t1, const Timer & t2);

#endif







