#include "ScriptInput.h"
#include <iostream>
#include <string>

const int NUM_SONAR = 8;

void printUsage( const char *exe ) {
  cout << "Usage: " << exe << " <script file> " << endl;
}

int main( int argc, char *argv[] ) {

  if ( argc > 1 ) {
    std::string fileName( argv[1] );
    ScriptInput scriptInput( fileName );
    double x;   double y;   double th;
    int sonarReadings[NUM_SONAR];
    
    while ( scriptInput.update( x, y, th, SONAR_SCAN, sonarReadings ) ) {
      cout << "encoder pos: " << x << " " << y << " " << th << endl;
      cout << "sonar scans: ";

      for ( int i = 0; i < NUM_SONAR; i++ )
	cout << sonarReadings[i] << " ";
      cout << endl;
    }
  } else
    printUsage( argv[0] );

  return 0;
}
